//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// Size of map
#define MAP_W (40)
#define MAP_H (25)

// Flags for tile walls
#define WF_L (0x01)
#define WF_R (0x02)
#define WF_U (0x04)
#define WF_D (0x08)

// Wall Type
#define WO_H (0x01)
#define WO_V (0x02)

//-----------------------------------------------------------------------------

enum {WALL_L,WALL_U,WALL_D,WALL_R};

//-----------------------------------------------------------------------------

typedef struct
{
	void*Owner;
	char WallsFlag;
	int ID;
}
TTile;

typedef struct
{
	TTile*Tile1;
	TTile*Tile2;
	int WallType;
}
TTCouple;

typedef struct
{
	int x,y;
	int WallTo;
	int WallFrom;
}
TStep;

//-----------------------------------------------------------------------------


void Initialize(void);
TTile* GetOwner(TTile*Tile);
void TC_Connect(TTCouple*TC);
void MakeMaze(void);
void NewMaze(void);

void FindWay(int x1, int y1, int x2, int y2);

void DrawScreen(void);

//-----------------------------------------------------------------------------

